import os
import subprocess

RECORD_FPS = 60
OUTPUT_FPS = 60
COPY_FRAMES = 30
FFMPEG_PATH = 'c:/ffmpeg/bin/ffmpeg.exe'

def process_frames(vidnum):
	if not os.path.exists('rec%02d' % vidnum):
		return

	last_frame = int(sorted(filter(lambda x: x.startswith('snp') and x.endswith('.pcx'), os.listdir('rec%02d/.' % vidnum)))[-1][3:-4])
	data = open('rec%02d/snp%05d.pcx' % (vidnum, last_frame), 'rb').read()

	for x in xrange(1,COPY_FRAMES+1):
		open('rec%02d/snp%05d.pcx' % (vidnum, (last_frame + x)), 'wb').write(data)

def convert_frames_to_video(vidnum):
	if not os.path.exists('F:/Elma Vid/32 Cup/rec%02d/mov' % vidnum):
		os.makedirs('F:/Elma Vid/32 Cup/rec%02d/mov' % vidnum)

	pathstr = 'rec%02d/' % vidnum

	subprocess.call([FFMPEG_PATH,
		'-framerate', str(RECORD_FPS),
		'-i', pathstr + 'snp%05d.pcx',
		'-vcodec', 'rawvideo',
		'-r', str(OUTPUT_FPS),
		'-pix_fmt', 'yuv420p',
		'F:/Elma Vid/32 Cup/rec%02d/mov/output.avi' % vidnum])

#	subprocess.call([FFMPEG_PATH,
#		'-framerate', str(RECORD_FPS),
#		'-i', pathstr + 'snp%05d.pcx',
#		'-c:v', 'libx264',
#		'-strict', 'experimental',
#		'-tune', 'fastdecode',
#		'-preset', 'veryslow',
#		'-r', str(OUTPUT_FPS),
#		'-crf', '18',
#		'-pix_fmt', 'yuv420p',
#		'int%02d/mov/output_n.mp4' % vidnum])

if __name__ == "__main__":
	os.chdir(os.path.dirname(os.path.realpath(__file__)))
	for x in xrange(1,55):
		if os.path.exists('rec%02d' % x):
			print x
			process_frames(x)
			convert_frames_to_video(x)
